diff -uNrd ircd-hybrid-6.3.1.dist/src/messages.tab ircd-hybrid-6.3.1/src/messages.tab
--- ircd-hybrid-6.3.1.dist/src/messages.tab	Sat Dec 29 22:25:48 2001
+++ ircd-hybrid-6.3.1/src/messages.tab	Mon May  5 08:57:59 2003
@@ -24,10 +24,10 @@
 
 static  char *  replies[] = {
 /* 000 */       NULL,
-/* 001  RPL_WELCOME, */ ":%s 001 %s :Welcome to the Internet Relay Network %s",
+/* 001  RPL_WELCOME, */ ":%s 001 %s :Welcome to the %s Internet Relay Chat Network %s!%s@%s",
 /* 002  RPL_YOURHOST,*/ ":%s 002 %s :Your host is %s, running version %s",
 /* 003  RPL_CREATED, */ ":%s 003 %s :This server was created %s",
-/* 004  RPL_MYINFO, */ ":%s 004 %s %s %s oOiwszcrkfydnxb biklmnopstve",
+/* 004  RPL_MYINFO, */ ":%s 004 %s %s %s oOiwszcrkfydnxbluja biklmnopstve",
 /* 005  RPL_ISUPPORT, */ ":%s 005 %s %s :are supported by this server",
 /* 006 */       NULL,
 /* 007 */       NULL,
@@ -38,9 +38,9 @@
 /* 012 */       NULL,
 /* 013 */       NULL,
 /* 014 */       NULL,
-/* 015 */       NULL,
+/* 015 RPL_MAP, */ ":%s 015 %s :%s",
 /* 016 */       NULL,
-/* 017 */       NULL,
+/* 017 RPL_MAPEND, */ ":%s 017 %s :End of /MAP",
 /* 018 */       NULL,
 /* 019 */       NULL,
 /* 020 */       NULL,
@@ -257,8 +257,8 @@
 /* 231 */       NULL,
 /* 232 */       NULL,
 /* 233 */       NULL,
-/* 234 RPL_SERVLIST, */ NULL,
-/* 235 RPL_SERVLISTEND, */ NULL,
+/* 234 */       NULL,
+/* 235 */       NULL,
 /* 236 */       NULL,
 /* 237 */       NULL,
 /* 238 */       NULL,
@@ -268,11 +268,11 @@
 /* 242 RPL_STATSUPTIME,*/       ":%s 242 %s :Server Up %d days, %d:%02d:%02d",
 /* 243 RPL_STATSOLINE, */       ":%s 243 %s %c %s@%s * %s %s %d %s",
 /* 244 RPL_STATSHLINE, */       ":%s 244 %s %c %s * %s %d %d", 
-/* 245 RPL_STATSSLINE, */       ":%s 245 %s %c %s * %s %d %d", 
+/* 245 */       NULL,
 /* 246 */       NULL,
 /* 247 RPL_STATSXLINE, */       ":%s 247 %s X %s %s * * 0 0",
 
-/* 248 RPL_STATSULINE, */       ":%s 248 %s U %s %s",
+/* 248 */       NULL,
 /* 249 */       NULL,
 /* 250 RPL_STATSCONN, */
                     ":%s 250 %s :Highest connection count: %d (%d clients) (%d since server was (re)started)",
@@ -287,7 +287,7 @@
 /* 258 RPL_ADMINLOC2, */        ":%s 258 %s :%s",
 /* 259 RPL_ADMINEMAIL, */       ":%s 259 %s :%s",
 /* 260 */       NULL,
-/* 261 RPL_TRACELOG, */         ":%s 261 %s File %s %d",
+/* 261 */       NULL,
 /* 262 RPL_ENDOFTRACE, */       ":%s 262 %s %s :End of TRACE",
 /* 263 RPL_LOAD2HI, */          
 ":%s 263 %s :Server load is temporarily too heavy. Please wait a while and try again.",
@@ -369,7 +369,7 @@
 /* 335 */       NULL,
 /* 336 */       NULL,
 /* 337 */       NULL,
-/* 338 */       NULL,
+/* 338 RPL_WHOISACTUALLY, */    ":%s 338 %s %s %s :actually using host",
 /* 339 */       NULL,
 /* 340 */       NULL,
 /* 341 RPL_INVITING, */         ":%s 341 %s %s %s",
@@ -396,7 +396,7 @@
 /* 358 */       NULL,
 /* 359 */       NULL,
 /* 360 */       NULL,
-/* 361 RPL_KILLDONE, */ NULL,
+/* 361 */       NULL,
 /* 362 RPL_CLOSING, */          ":%s 362 %s %s :Closed. Status = %d",
 /* 363 RPL_CLOSEEND, */         ":%s 363 %s %d: Connections Closed",
 /* 364 RPL_LINKS, */            ":%s 364 %s %s %s :%d %s",
@@ -423,8 +423,8 @@
 /* 381 RPL_YOUREOPER, */        ":%s 381 %s :You have entered... the Twilight Zone!.",
 /* 382 RPL_REHASHING, */        ":%s 382 %s %s :Rehashing",
 /* 383 */       NULL,
-/* 384 RPL_MYPORTIS, */         ":%s 384 %s %d :Port to local server is\r\n",
-/* 385 RPL_NOTOPERANYMORE, */   NULL,
+/* 384 */       NULL,
+/* 385 */       NULL,
 /* 386 */       NULL,
 /* 387 */       NULL,
 /* 388 */       NULL,
@@ -459,13 +459,17 @@
 /* 416 */       NULL,
 /* 417 */       NULL,
 /* 418 */       NULL,
+#ifdef STATS_IGNORED_NOTICE
+/* 419 ERR_STATSIGNORED, */     ":%s 419 %s :STATS %c request ignored",
+#else
 /* 419 */       NULL,
+#endif
 /* 420 */       NULL,
 /* 421 ERR_UNKNOWNCOMMAND, */   ":%s 421 %s %s :Unknown command",
 /* 422 ERR_NOMOTD, */           ":%s 422 %s :MOTD File is missing",
 /* 423 ERR_NOADMININFO, */
                 ":%s 423 %s %s :No administrative info available",
-/* 424 ERR_FILEERROR, */        ":%s 424 %s :File error doing %s on %s",
+/* 424 */       NULL,
 /* 425 */       NULL,
 /* 426 */       NULL,
 /* 427 */       NULL,
@@ -486,8 +490,8 @@
 /* 442 ERR_NOTONCHANNEL, */     ":%s 442 %s %s :You're not on that channel",
 /* 443 ERR_USERONCHANNEL, */    ":%s 443 %s %s %s :is already on channel",
 /* 444 ERR_NOLOGIN, */          ":%s 444 %s %s :User not logged in",
-/* 445 ERR_SUMMONDISABLED, */   ":%s 445 %s :SUMMON has been removed",
-/* 446 ERR_USERSDISABLED, */    ":%s 446 %s :USERS has been removed",
+/* 445 */       NULL,
+/* 446 */       NULL,
 /* 447 */       NULL,
 /* 448 */       NULL,
 /* 449 */       NULL,
@@ -507,8 +511,8 @@
 /* 463 ERR_NOPERMFORHOST, */    ":%s 463 %s :Your host isn't among the privileged",
 /* 464 ERR_PASSWDMISMATCH, */   ":%s 464 %s :Password Incorrect",
 /* 465 ERR_YOUREBANNEDCREEP, */ ":%s 465 %s :You are banned from this server- %s",
-/* 466 ERR_YOUWILLBEBANNED, */  NULL,
-/* 467 ERR_KEYSET, */           ":%s 467 %s %s :Channel key already set",
+/* 466 */  NULL,
+/* 467 */       NULL,
 /* 468 */       NULL,
 /* 469 */       NULL,
 /* 470 */       NULL,
@@ -518,7 +522,7 @@
 /* 474 ERR_BANNEDFROMCHAN, */   ":%s 474 %s %s :Cannot join channel (+b)",
 /* 475 ERR_BADCHANNELKEY, */    ":%s 475 %s %s :Cannot join channel (+k)",
 /* 476 ERR_BADCHANMASK, */      ":%s 476 %s %s :Bad Channel Mask",
-/* 477 ERR_MODELESS, */         ":%s 477 %s %s :Channel does not support modes",
+/* 477 */       NULL,
 /* 478 ERR_BANLISTFULL, */      ":%s 478 %s %s %s :Channel ban list is full",
 /* 479 ERR_BADCHANNAME */       ":%s 479 %s %s :Illegal channel name",
 /* 480 */       NULL,
@@ -526,7 +530,7 @@
                 ":%s 481 %s :Permission Denied- You're not an IRC operator",
 /* 482 ERR_CHANOPRIVSNEEDED, */ ":%s 482 %s %s :You're not channel operator",
 /* 483 ERR_CANTKILLSERVER, */   ":%s 483 %s :You can't kill a server!",
-/* 484 */       NULL,
+/* 484 ERR_RESTRICTED, */       ":%s 484 %s :You are restricted",
 /* 485 */       NULL,
 /* 486 */       NULL,
 /* 487 */       NULL,
@@ -546,7 +550,501 @@
 /* 501 ERR_UMODEUNKNOWNFLAG, */ ":%s 501 %s :Unknown MODE flag",
 /* 502 ERR_USERSDONTMATCH, */   ":%s 502 %s :Can't change mode for other users",
 /* 503 ERR_GHOSTEDCLIENT, */    ":%s 503 %s :Message could not be delivered to %s",
-/* 504 LAST ERR_LAST_ERR_MSG, */        ":%s 504 %s :Last Error Message"
+/* 504 */       NULL,
+/* 505 */       NULL,
+/* 506 */       NULL,
+/* 507 */       NULL,
+/* 508 */       NULL,
+/* 509 */       NULL,
+/* 510 */       NULL,
+/* 511 */       NULL,
+/* 512 */       NULL,
+/* 513 */       NULL,
+/* 514 */       NULL,
+/* 515 */       NULL,
+/* 516 */       NULL,
+/* 517 */       NULL,
+/* 518 */       NULL,
+/* 519 */       NULL,
+/* 520 */       NULL,
+/* 521 */       NULL,
+/* 522 */       NULL,
+/* 523 */       NULL,
+/* 524 */       NULL,
+/* 525 */       NULL,
+/* 526 */       NULL,
+/* 527 */       NULL,
+/* 528 */       NULL,
+/* 529 */       NULL,
+/* 530 */       NULL,
+/* 531 */       NULL,
+/* 532 */       NULL,
+/* 533 */       NULL,
+/* 534 */       NULL,
+/* 535 */       NULL,
+/* 536 */       NULL,
+/* 537 */       NULL,
+/* 538 */       NULL,
+/* 539 */       NULL,
+/* 540 */       NULL,
+/* 541 */       NULL,
+/* 542 */       NULL,
+/* 543 */       NULL,
+/* 544 */       NULL,
+/* 545 */       NULL,
+/* 546 */       NULL,
+/* 547 */       NULL,
+/* 548 */       NULL,
+/* 549 */       NULL,
+/* 550 */       NULL,
+/* 551 */       NULL,
+/* 552 */       NULL,
+/* 553 */       NULL,
+/* 554 */       NULL,
+/* 555 */       NULL,
+/* 556 */       NULL,
+/* 557 */       NULL,
+/* 558 */       NULL,
+/* 559 */       NULL,
+/* 560 */       NULL,
+/* 561 */       NULL,
+/* 562 */       NULL,
+/* 563 */       NULL,
+/* 564 */       NULL,
+/* 565 */       NULL,
+/* 566 */       NULL,
+/* 567 */       NULL,
+/* 568 */       NULL,
+/* 569 */       NULL,
+/* 570 */       NULL,
+/* 571 */       NULL,
+/* 572 */       NULL,
+/* 573 */       NULL,
+/* 574 */       NULL,
+/* 575 */       NULL,
+/* 576 */       NULL,
+/* 577 */       NULL,
+/* 578 */       NULL,
+/* 579 */       NULL,
+/* 580 */       NULL,
+/* 581 */       NULL,
+/* 582 */       NULL,
+/* 583 */       NULL,
+/* 584 */       NULL,
+/* 585 */       NULL,
+/* 586 */       NULL,
+/* 587 */       NULL,
+/* 588 */       NULL,
+/* 589 */       NULL,
+/* 590 */       NULL,
+/* 591 */       NULL,
+/* 592 */       NULL,
+/* 593 */       NULL,
+/* 594 */       NULL,
+/* 595 */       NULL,
+/* 596 */       NULL,
+/* 597 */       NULL,
+/* 598 */       NULL,
+/* 599 */       NULL,
+/* 600 */       NULL,
+/* 601 */       NULL,
+/* 602 */       NULL,
+/* 603 */       NULL,
+/* 604 */       NULL,
+/* 605 */       NULL,
+/* 606 */       NULL,
+/* 607 */       NULL,
+/* 608 */       NULL,
+/* 609 */       NULL,
+/* 610 */       NULL,
+/* 611 */       NULL,
+/* 612 */       NULL,
+/* 613 */       NULL,
+/* 614 */       NULL,
+/* 615 */       NULL,
+/* 616 */       NULL,
+/* 617 */       NULL,
+/* 618 */       NULL,
+/* 619 */       NULL,
+/* 620 */       NULL,
+/* 621 */       NULL,
+/* 622 */       NULL,
+/* 623 */       NULL,
+/* 624 */       NULL,
+/* 625 */       NULL,
+/* 626 */       NULL,
+/* 627 */       NULL,
+/* 628 */       NULL,
+/* 629 */       NULL,
+/* 630 */       NULL,
+/* 631 */       NULL,
+/* 632 */       NULL,
+/* 633 */       NULL,
+/* 634 */       NULL,
+/* 635 */       NULL,
+/* 636 */       NULL,
+/* 637 */       NULL,
+/* 638 */       NULL,
+/* 639 */       NULL,
+/* 640 */       NULL,
+/* 641 */       NULL,
+/* 642 */       NULL,
+/* 643 */       NULL,
+/* 644 */       NULL,
+/* 645 */       NULL,
+/* 646 */       NULL,
+/* 647 */       NULL,
+/* 648 */       NULL,
+/* 649 */       NULL,
+/* 650 */       NULL,
+/* 651 */       NULL,
+/* 652 */       NULL,
+/* 653 */       NULL,
+/* 654 */       NULL,
+/* 655 */       NULL,
+/* 656 */       NULL,
+/* 657 */       NULL,
+/* 658 */       NULL,
+/* 659 */       NULL,
+/* 660 */       NULL,
+/* 661 */       NULL,
+/* 662 */       NULL,
+/* 663 */       NULL,
+/* 664 */       NULL,
+/* 665 */       NULL,
+/* 666 */       NULL,
+/* 667 */       NULL,
+/* 668 */       NULL,
+/* 669 */       NULL,
+/* 670 */       NULL,
+/* 671 */       NULL,
+/* 672 */       NULL,
+/* 673 */       NULL,
+/* 674 */       NULL,
+/* 675 */       NULL,
+/* 676 */       NULL,
+/* 677 */       NULL,
+/* 678 */       NULL,
+/* 679 */       NULL,
+/* 680 */       NULL,
+/* 681 */       NULL,
+/* 682 */       NULL,
+/* 683 */       NULL,
+/* 684 */       NULL,
+/* 685 */       NULL,
+/* 686 */       NULL,
+/* 687 */       NULL,
+/* 688 */       NULL,
+/* 689 */       NULL,
+/* 690 */       NULL,
+/* 691 */       NULL,
+/* 692 */       NULL,
+/* 693 */       NULL,
+/* 694 */       NULL,
+/* 695 */       NULL,
+/* 696 */       NULL,
+/* 697 */       NULL,
+/* 698 */       NULL,
+/* 699 */       NULL,
+/* 700 */       NULL,
+/* 701 */       NULL,
+/* 702 */       NULL,
+/* 703 */       NULL,
+/* 704 */       NULL,
+/* 705 */       NULL,
+/* 706 */       NULL,
+/* 707 */       NULL,
+/* 708 */       NULL,
+/* 709 RPL_ETRACE, */           ":%s 709 %s %s %d %s %s %s %s :%s",
+/* 710 RPL_KNOCK, */            ":%s 710 %s %s %s!%s@%s :has asked for an invite.",
+/* 711 RPL_KNOCKDLVR */         ":%s 711 %s %s :Your KNOCK has been delivered.",
+/* 712 ERR_TOOMANYKNOCK */      ":%s 712 %s %s :Too many KNOCKs (%s).",
+/* 713 ERR_CHANOPEN */          ":%s 713 %s %s :Channel is open.",
+/* 714 ERR_KNOCKONCHAN */       ":%s 714 %s %s :You are already on that channel.",
+/* 715 ERR_KNOCKDISABLED */     ":%s 715 %s :KNOCKs are disabled.",
+/* 716 */       NULL,
+/* 717 */       NULL,
+/* 718 */       NULL,
+/* 719 */       NULL,
+/* 720 */       NULL,
+/* 721 */       NULL,
+/* 722 */       NULL,
+/* 723 */       NULL,
+/* 724 */       NULL,
+/* 725 */       NULL,
+/* 726 */       NULL,
+/* 727 */       NULL,
+/* 728 */       NULL,
+/* 729 */       NULL,
+/* 730 */       NULL,
+/* 731 */       NULL,
+/* 732 */       NULL,
+/* 733 */       NULL,
+/* 734 */       NULL,
+/* 735 */       NULL,
+/* 736 */       NULL,
+/* 737 */       NULL,
+/* 738 */       NULL,
+/* 739 */       NULL,
+/* 740 */       NULL,
+/* 741 */       NULL,
+/* 742 */       NULL,
+/* 743 */       NULL,
+/* 744 */       NULL,
+/* 745 */       NULL,
+/* 746 */       NULL,
+/* 747 */       NULL,
+/* 748 */       NULL,
+/* 749 */       NULL,
+/* 750 */       NULL,
+/* 751 */       NULL,
+/* 752 */       NULL,
+/* 753 */       NULL,
+/* 754 */       NULL,
+/* 755 */       NULL,
+/* 756 */       NULL,
+/* 757 */       NULL,
+/* 758 */       NULL,
+/* 759 */       NULL,
+/* 760 */       NULL,
+/* 761 */       NULL,
+/* 762 */       NULL,
+/* 763 */       NULL,
+/* 764 */       NULL,
+/* 765 */       NULL,
+/* 766 */       NULL,
+/* 767 */       NULL,
+/* 768 */       NULL,
+/* 769 */       NULL,
+/* 770 */       NULL,
+/* 771 */       NULL,
+/* 772 */       NULL,
+/* 773 */       NULL,
+/* 774 */       NULL,
+/* 775 */       NULL,
+/* 776 */       NULL,
+/* 777 */       NULL,
+/* 778 */       NULL,
+/* 779 */       NULL,
+/* 780 */       NULL,
+/* 781 */       NULL,
+/* 782 */       NULL,
+/* 783 */       NULL,
+/* 784 */       NULL,
+/* 785 */       NULL,
+/* 786 */       NULL,
+/* 787 */       NULL,
+/* 788 */       NULL,
+/* 789 */       NULL,
+/* 790 */       NULL,
+/* 791 */       NULL,
+/* 792 */       NULL,
+/* 793 */       NULL,
+/* 794 */       NULL,
+/* 795 */       NULL,
+/* 796 */       NULL,
+/* 797 */       NULL,
+/* 798 */       NULL,
+/* 799 */       NULL,
+/* 800 */       NULL,
+/* 801 */       NULL,
+/* 802 */       NULL,
+/* 803 */       NULL,
+/* 804 */       NULL,
+/* 805 */       NULL,
+/* 806 */       NULL,
+/* 807 */       NULL,
+/* 808 */       NULL,
+/* 809 */       NULL,
+/* 810 */       NULL,
+/* 811 */       NULL,
+/* 812 */       NULL,
+/* 813 */       NULL,
+/* 814 */       NULL,
+/* 815 */       NULL,
+/* 816 */       NULL,
+/* 817 */       NULL,
+/* 818 */       NULL,
+/* 819 */       NULL,
+/* 820 */       NULL,
+/* 821 */       NULL,
+/* 822 */       NULL,
+/* 823 */       NULL,
+/* 824 */       NULL,
+/* 825 */       NULL,
+/* 826 */       NULL,
+/* 827 */       NULL,
+/* 828 */       NULL,
+/* 829 */       NULL,
+/* 830 */       NULL,
+/* 831 */       NULL,
+/* 832 */       NULL,
+/* 833 */       NULL,
+/* 834 */       NULL,
+/* 835 */       NULL,
+/* 836 */       NULL,
+/* 837 */       NULL,
+/* 838 */       NULL,
+/* 839 */       NULL,
+/* 840 */       NULL,
+/* 841 */       NULL,
+/* 842 */       NULL,
+/* 843 */       NULL,
+/* 844 */       NULL,
+/* 845 */       NULL,
+/* 846 */       NULL,
+/* 847 */       NULL,
+/* 848 */       NULL,
+/* 849 */       NULL,
+/* 850 */       NULL,
+/* 851 */       NULL,
+/* 852 */       NULL,
+/* 853 */       NULL,
+/* 854 */       NULL,
+/* 855 */       NULL,
+/* 856 */       NULL,
+/* 857 */       NULL,
+/* 858 */       NULL,
+/* 859 */       NULL,
+/* 860 */       NULL,
+/* 861 */       NULL,
+/* 862 */       NULL,
+/* 863 */       NULL,
+/* 864 */       NULL,
+/* 865 */       NULL,
+/* 866 */       NULL,
+/* 867 */       NULL,
+/* 868 */       NULL,
+/* 869 */       NULL,
+/* 870 */       NULL,
+/* 871 */       NULL,
+/* 872 */       NULL,
+/* 873 */       NULL,
+/* 874 */       NULL,
+/* 875 */       NULL,
+/* 876 */       NULL,
+/* 877 */       NULL,
+/* 878 */       NULL,
+/* 879 */       NULL,
+/* 880 */       NULL,
+/* 881 */       NULL,
+/* 882 */       NULL,
+/* 883 */       NULL,
+/* 884 */       NULL,
+/* 885 */       NULL,
+/* 886 */       NULL,
+/* 887 */       NULL,
+/* 888 */       NULL,
+/* 889 */       NULL,
+/* 890 */       NULL,
+/* 891 */       NULL,
+/* 892 */       NULL,
+/* 893 */       NULL,
+/* 894 */       NULL,
+/* 895 */       NULL,
+/* 896 */       NULL,
+/* 897 */       NULL,
+/* 898 */       NULL,
+/* 899 */       NULL,
+/* 900 */       NULL,
+/* 901 */       NULL,
+/* 902 */       NULL,
+/* 903 */       NULL,
+/* 904 */       NULL,
+/* 905 */       NULL,
+/* 906 */       NULL,
+/* 907 */       NULL,
+/* 908 */       NULL,
+/* 909 */       NULL,
+/* 910 */       NULL,
+/* 911 */       NULL,
+/* 912 */       NULL,
+/* 913 */       NULL,
+/* 914 */       NULL,
+/* 915 */       NULL,
+/* 916 */       NULL,
+/* 917 */       NULL,
+/* 918 */       NULL,
+/* 919 */       NULL,
+/* 920 */       NULL,
+/* 921 */       NULL,
+/* 922 */       NULL,
+/* 923 */       NULL,
+/* 924 */       NULL,
+/* 925 */       NULL,
+/* 926 */       NULL,
+/* 927 */       NULL,
+/* 928 */       NULL,
+/* 929 */       NULL,
+/* 930 */       NULL,
+/* 931 */       NULL,
+/* 932 */       NULL,
+/* 933 */       NULL,
+/* 934 */       NULL,
+/* 935 */       NULL,
+/* 936 */       NULL,
+/* 937 */       NULL,
+/* 938 */       NULL,
+/* 939 */       NULL,
+/* 940 */       NULL,
+/* 941 */       NULL,
+/* 942 */       NULL,
+/* 943 */       NULL,
+/* 944 */       NULL,
+/* 945 */       NULL,
+/* 946 */       NULL,
+/* 947 */       NULL,
+/* 948 */       NULL,
+/* 949 */       NULL,
+/* 950 */       NULL,
+/* 951 */       NULL,
+/* 952 */       NULL,
+/* 953 */       NULL,
+/* 954 */       NULL,
+/* 955 */       NULL,
+/* 956 */       NULL,
+/* 957 */       NULL,
+/* 958 */       NULL,
+/* 959 */       NULL,
+/* 960 */       NULL,
+/* 961 */       NULL,
+/* 962 */       NULL,
+/* 963 */       NULL,
+/* 964 */       NULL,
+/* 965 */       NULL,
+/* 966 */       NULL,
+/* 967 */       NULL,
+/* 968 */       NULL,
+/* 969 */       NULL,
+/* 970 */       NULL,
+/* 971 */       NULL,
+/* 972 */       NULL,
+/* 973 */       NULL,
+/* 974 */       NULL,
+/* 975 */       NULL,
+/* 976 */       NULL,
+/* 977 */       NULL,
+/* 978 */       NULL,
+/* 979 */       NULL,
+/* 980 */       NULL,
+/* 981 */       NULL,
+/* 982 */       NULL,
+/* 983 */       NULL,
+/* 984 */       NULL,
+/* 985 */       NULL,
+/* 986 */       NULL,
+/* 987 */       NULL,
+/* 988 */       NULL,
+/* 989 */       NULL,
+/* 990 */       NULL,
+/* 991 */       NULL,
+/* 992 */       NULL,
+/* 993 */       NULL,
+/* 994 */       NULL,
+/* 995 */       NULL,
+/* 996 */       NULL,
+/* 997 */       NULL,
+/* 998 */       NULL,
+/* 999 LAST ERR_LAST_ERR_MSG,*/ ":%s 999 %s :Last Error Message"
 };
-
 
diff -uNrd ircd-hybrid-6.3.1.dist/src/mtrie_conf.c ircd-hybrid-6.3.1/src/mtrie_conf.c
--- ircd-hybrid-6.3.1.dist/src/mtrie_conf.c	Thu Mar 21 19:04:57 2002
+++ ircd-hybrid-6.3.1/src/mtrie_conf.c	Sat Apr 26 20:21:47 2003
@@ -80,7 +80,11 @@
 static void find_or_add_user_piece(DOMAIN_PIECE *,struct ConfItem *,int,char *);
 static struct ConfItem *find_user_piece(DOMAIN_PIECE *,int,char *, const char* user);
 
+static struct ConfItem* look_for_dup_in_unsortable_ilines(const char* host,
+const char* user);
 static struct ConfItem* look_in_unsortable_ilines(const char* host, const char* user);
+static struct ConfItem* look_for_dup_in_unsortable_klines(const char* host,
+const char* user);
 static struct ConfItem* look_in_unsortable_klines(const char* host, const char* user);
 static struct ConfItem* find_wild_card_iline(const char* user);
 
@@ -117,6 +121,7 @@
   char tokenized_host[HOSTLEN+1];
   unsigned long ip_host;
   unsigned long ip_mask;
+  struct ConfItem *aconf2;
 
   /* Sanity tests are always good */
   if(!aconf->host || !aconf->user)
@@ -146,6 +151,13 @@
 
       if(aconf->status & CONF_CLIENT)
         {
+          aconf2 = look_for_dup_in_unsortable_ilines(aconf->host, aconf->user);
+          if (aconf2 != NULL)
+            {
+              report_dup('I', aconf2);
+              free(aconf);
+              return;
+            }
           if(unsortable_list_ilines)
             {
               aconf->next = unsortable_list_ilines;
@@ -156,6 +168,16 @@
         }
       else
         {
+          /* This is a CPU hit, but it prevents a mess of duplicate unsortable
+           * klines. -Hwy
+           */
+          aconf2 = look_for_dup_in_unsortable_klines(aconf->host, aconf->user);
+          if (aconf2 != NULL)
+            {
+              report_dup('K', aconf2);
+              free(aconf);
+              return;
+            }
           if(unsortable_list_klines)
             {
               aconf->next = unsortable_list_klines;
@@ -170,6 +192,13 @@
     case -2:
       if(aconf->status & CONF_CLIENT)
         {
+          aconf2 = find_wild_card_iline(aconf->user);
+          if (aconf2 != NULL)
+            {
+              report_dup('I', aconf2);
+              free(aconf);
+              return;
+            }
           if(wild_card_ilines)
             {
               aconf->next = wild_card_ilines;
@@ -180,6 +209,16 @@
         }
       else
         {
+          /* This is a CPU hit, but it prevents a mess of duplicate unsortable
+           * klines. -Hwy
+           */
+          aconf2 = look_for_dup_in_unsortable_klines(aconf->host, aconf->user);
+          if (aconf2 != NULL)
+            {
+              report_dup('K', aconf2);
+              free(aconf);
+              return;
+            }
           if(unsortable_list_klines)
             {
               aconf->next = unsortable_list_klines;
@@ -1095,6 +1134,33 @@
 }
 
 /*
+ * look_in_unsortable_ilines()
+ *
+ * inputs       - host name
+ *              - username
+ * output       - struct ConfItem pointer or NULL
+ * side effects -
+ *
+ * scan the link list of unsortable patterns
+ */
+            
+static struct ConfItem *
+look_for_dup_in_unsortable_ilines(const char* host, const char* user)
+{
+  struct ConfItem *found_conf;
+
+  for(found_conf=unsortable_list_ilines;found_conf;found_conf=found_conf->next)
+    {
+      if((irccmp(found_conf->host,host) == 0) &&
+         (irccmp(found_conf->user,user) == 0))
+        {
+            return(found_conf);
+        }
+    }
+  return(NULL);
+}
+
+/*
  * look_in_unsortable_klines()
  *
  * inputs       - host name
@@ -1120,6 +1186,31 @@
 }
 
 /*
+ * look_for_dup_in_unsortable_klines()
+ *
+ * inputs       - host name   
+ *              - username
+ * output       - struct ConfItem pointer or NULL
+ * side effects -
+ *
+ * scan the link list of unsortable patterns
+ */
+  
+static struct ConfItem *
+look_for_dup_in_unsortable_klines(const char* host, const char* user)
+{
+  struct ConfItem *found_conf;
+
+  for(found_conf=unsortable_list_klines;found_conf;found_conf=found_conf->next)
+    {
+      if((irccmp(found_conf->host,host) == 0) &&
+         (irccmp(found_conf->user,user) == 0))
+        return(found_conf);
+    }
+  return(NULL);
+}
+
+/*
  * find_wild_card_iline()
  *
  * inputs       - username
@@ -1361,7 +1452,8 @@
       for(found_conf = unsortable_list_klines;
           found_conf;found_conf=found_conf->next)
         {
-          get_printable_conf(found_conf, &name, &host, &pass, &user, &port);
+          get_printable_conf(found_conf, &name, &host, &pass,
+                                    &user, &port);
 
 	  sendto_one(sptr, form_str(RPL_STATSKLINE), me.name,
 		     sptr->name, 'K', host,
@@ -1400,6 +1492,12 @@
     *prefix_ptr++ = '%';
   if (IsConfDoSpoofIp(aconf))
     *prefix_ptr++ = '=';
+  if (IsMustResolve(aconf))
+    *prefix_ptr++ = '/';
+#ifdef CHECK_CLONE
+  if (IsConfCloneExempt(aconf))
+    *prefix_ptr++ = '{';
+#endif
 
 #ifdef E_LINES_OPER_ONLY
   if(IsAnOper(sptr))
diff -uNrd ircd-hybrid-6.3.1.dist/src/numeric.c ircd-hybrid-6.3.1/src/numeric.c
--- ircd-hybrid-6.3.1.dist/src/numeric.c	Wed Nov 21 20:19:21 2001
+++ ircd-hybrid-6.3.1/src/numeric.c	Mon Apr 21 16:01:50 2003
@@ -24,14 +24,8 @@
 #include "numeric.h"
 #include "irc_string.h"
 #include "common.h"     /* NULL cripes */
-
 #include <assert.h>
-
-#ifdef CUSTOM_ERR            /* XXX ick */
-#include "messages_cust.tab"
-#else
 #include "messages.tab"
-#endif
 
 char numbuff[512];
 
diff -uNrd ircd-hybrid-6.3.1.dist/src/parse.c ircd-hybrid-6.3.1/src/parse.c
--- ircd-hybrid-6.3.1.dist/src/parse.c	Sat Dec 29 22:25:48 2001
+++ ircd-hybrid-6.3.1/src/parse.c	Sat Apr 19 21:06:45 2003
@@ -721,6 +721,11 @@
           ** with numerics which can happen with nick collisions.
           ** - Avalon
           */
+
+	  /* comstud ircd hack, it bounces +a modes */
+	  if((atoi(numeric) == ERR_UMODEUNKNOWNFLAG) && MyClient(acptr))
+	    return 0;
+
           if (!IsMe(acptr) && IsPerson(acptr))
             sendto_prefix_one(acptr, sptr,":%s %s %s%s",
                               parv[0], numeric, nick, buffer);
diff -uNrd ircd-hybrid-6.3.1.dist/src/restart.c ircd-hybrid-6.3.1/src/restart.c
--- ircd-hybrid-6.3.1.dist/src/restart.c	Sat Dec  8 02:06:14 2001
+++ ircd-hybrid-6.3.1/src/restart.c	Sat Apr 19 21:06:45 2003
@@ -39,6 +39,9 @@
 
   log(L_NOTICE, "Restarting server...");
   flush_connections(0);
+#ifdef SAVE_MAXCLIENT
+  write_stats();
+#endif
 
   for (i = 0; i < MAXCONNECTIONS; ++i)
     close(i);
diff -uNrd ircd-hybrid-6.3.1.dist/src/s_auth.c ircd-hybrid-6.3.1/src/s_auth.c
--- ircd-hybrid-6.3.1.dist/src/s_auth.c	Tue Dec  4 02:44:37 2001
+++ ircd-hybrid-6.3.1/src/s_auth.c	Sat Apr 19 21:15:18 2003
@@ -398,8 +398,8 @@
 
   sendheader(client, REPORT_DO_DNS);
 
-  adns_getaddr(&client->ip, client->dns_query);
-  SetDNSPending(auth);
+  if(!adns_getaddr(&client->ip, client->dns_query))
+    SetDNSPending(auth);
 
   if (start_auth_query(auth))
     link_auth_request(auth, &AuthPollList);
